package net.sf.corn.converter.json;

import java.lang.reflect.Constructor;
import java.math.BigDecimal;
import java.math.BigInteger;

import net.sf.corn.converter.ConversionException;
import net.sf.corn.converter.ObjectReferenceMap;

class CnvNumeric extends AbstractJsonConverter {

	CnvNumeric() {
		getConvertibles().add(short.class);
		getConvertibles().add(Short.class);
		getConvertibles().add(long.class);
		getConvertibles().add(Long.class);
		getConvertibles().add(int.class);
		getConvertibles().add(Integer.class);
		getConvertibles().add(float.class);
		getConvertibles().add(Float.class);
		getConvertibles().add(double.class);
		getConvertibles().add(Double.class);
		getConvertibles().add(byte.class);
		getConvertibles().add(Byte.class);
		getConvertibles().add(boolean.class);
		getConvertibles().add(Boolean.class);
		getConvertibles().add(BigInteger.class);
		getConvertibles().add(BigDecimal.class);
	}

	protected JsTypeObject inToTarget(Object o, ObjectReferenceMap referenceMap)
			throws ConversionException {
		return new JsTypeSimple(o);
	}

	protected Object inToJava(Class<?> clazz, JsTypeObject obj)
			throws ConversionException {
		if (!obj.isSimple()) {
			throw new ConversionException(this.getClass().getName()
					+ " can't be used as converter for " + clazz.getName());
		}
		Object retVal = null;
		try {
			Constructor<?> stringConstructor = clazz
					.getDeclaredConstructor(String.class);
			retVal = stringConstructor.newInstance(obj.toStringValue());
		} catch (Exception e) {
			throw new ConversionException(
					"An exception occured while transforming json to "
							+ clazz.getName(), e);
		}
		// Reverse must be proven
		if (!obj.toStringValue().equals(retVal.toString())) {
			throw new ConversionException(this.getClass().getName()
					+ " can't be used as converter for " + clazz.getName());
		}
		return retVal;
	}

	@Override
	public boolean isSubjectForCircularReferenceCheck() {
		return false;
	}

}
